/*****************************************************************
 * Tool: SEAT - Software Exploration and Analysis Tool			 *
 *																 *
 * Class: MethodInvocationNode.java								 *	
 * Package: core.dynamic										 *
 *																 *
 * @author: Abdelwahab Hamou-Lhadj								 *
 *																 *	
 * Affiliation: Knowledge Based Reverse Engineering Group		 *
 *				SITE - University of Ottawa						 *
 *																 *
 * @version: 1.0 - July 2003									 *
 * 																 *
 * Modifications: 												 *
 * (please add date of modifications and author after this line) *	
 *																 *
 *****************************************************************/

package seat.model.core.dynamic;

import seat.model.core.structure.BehaviouralElement;

public class MethodInvocationNode extends RoutineCallNode
{
  
  /** Creates a method invocation node
   *
   * @param behavElem the behavioural element that is associated with this node
   *
   */
  
  public MethodInvocationNode(BehaviouralElement behavElem) 
  {
  	super(behavElem);
  }
 
  /** Creates a method invocation node by specifying the certificate
   *
   * @param certificate a unique certificate that identifies the subtree rooted at this node
   * @param behavElem the behavioural element that is associated with this node
   *
   */
  
  public MethodInvocationNode(BehaviouralElement behavElem, int certificate) 
  {
  	super(behavElem, certificate);
  }
  
  /** Returns the node label. 
   *
   * @return the node label
   *
   */
   
  public String getLabel()
  {
  	 return getBehaviouralElement().getSignature();
  }
}