/*****************************************************************
 * Tool: SEAT - Software Exploration and Analysis Tool			 *
 *																 *
 * Class: RoutineCallTrace.java									 *	
 * Package: core.dynamic										 *
 *																 *
 * @author: Abdelwahab Hamou-Lhadj								 *
 *																 *	
 * Affiliation: Knowledge Based Reverse Engineering Group		 *
 *				SITE - University of Ottawa						 *
 *																 *
 * @version: 1.0 - July 2003									 *
 * 																 *
 * Modifications: 												 *
 * (please add date of modifications and author after this line) *	
 *																 *
 *****************************************************************/

package seat.model.core.dynamic;

import java.io.IOException;

import seat.io.ITraceSource;
import seat.io.RoutineCallTraceLoader;

public class RoutineCallTrace extends TreeTrace
{
  /** Creates a routine call trace
   *
   * @param scenario the system scenario that corresponds to this trace
   * @param file source file of this trace
   *
   */
    
  public RoutineCallTrace(Scenario scenario, ITraceSource source) 
  {
  	super(scenario, source);
  }
  
  /** Loads the trace into memory. */
    
  public void open() throws IOException
  {
  	RoutineCallTraceLoader loader = new RoutineCallTraceLoader(this);
  	loader.open();
  }
}