/*****************************************************************
 * Tool: SEAT - Software Exploration and Analysis Tool			 *
 *																 *
 * Class: Scenario.java											 *	
 * Package: core.dynamic										 *
 *																 *
 * Author: Abdelwahab Hamou-Lhadj								 *
 *																 *	
 * Affiliation: Knowledge Based Reverse Engineering Group		 *
 *				SITE - University of Ottawa						 *
 *																 *
 * Version: 1.0 - July 2003										 *
 * 																 *
 * Modifications: 												 *
 * (please add date of modifications and author after this line) *	
 *																 *
 *****************************************************************/

package seat.model.core.dynamic;

import seat.model.core.structure.SoftwareSystem;

public class Scenario
{
  private String name;   // Name of the scenario
  private SoftwareSystem system; // Software system that defines this scenario
  
  /** Creates a Scenario object 
   * 
   * @param system software system that defines this scenario
   * @param name name of the scenario
   *
   */
   
  public Scenario(SoftwareSystem system, String name)
  { 	
    this.system = system;
 	this.name = name;
 	this.system.addScenario(this);
  }
  
  /** Returns the scenario name 
   * 
   * @return scenario name
   *
   */

  public String getName()
  {
  	return name;
  }
  
  /** Returns the software system object 
   * 
   * @return the software system object
   *
   */

  public SoftwareSystem getSystem()
  {
  	return system;
  }
}
