/*****************************************************************
 * Tool: SEAT - Software Exploration and Analysis Tool			 *
 *																 *
 * Class: BehaviouralElement.java								 *	
 *																 *
 * @author: Abdelwahab Hamou-Lhadj								 *
 *																 *	
 * Affiliation: Knowledge Based Reverse Engineering Group		 *
 *				SITE - University of Ottawa						 *
 *																 *
 * @version: 1.0 - July 2003									 *
 * 																 *
 * Modifications: 												 *
 * (please add date of modifications and author after this line) *	
 *																 *
 *****************************************************************/
 
package seat.model.core.structure;

public abstract class BehaviouralElement extends ModelElement
{
 
 /** Creates a behaviouoral element object. 
  * A behavioural element is eihter a routine or a method
  * 
  * @param name name of the behavioural element (e.g routine name).
  *
  */
 
 public BehaviouralElement(SoftwareSystem sys, String name)
 { 	
 	super(sys, name);
 }
 
 /** Abstract method to be overriden by subclasses.
  * It returns the signature of the behavoural element. 
  *
  * @return  signature of the behavioural element
  *
  */
 
 public abstract String getSignature();
 
}