/*****************************************************************
 * Tool: SEAT - Software Exploration and Analysis Tool			 *
 *																 *
 * Class: Routine.java										 	 *	
 *																 *
 * @author: Abdelwahab Hamou-Lhadj								 *
 *																 *	
 * Affiliation: Knowledge Based Reverse Engineering Group		 *
 *				SITE - University of Ottawa						 *
 *																 *
 * @version: 1.0 - July 2003									 *
 * 																 *
 * Modifications: 												 *
 * (please add date of modifications and author after this line) *	
 *																 *
 *****************************************************************/
 
package seat.model.core.structure;

public class Routine extends BehaviouralElement
{
  /** Creates a routine object 
   * 
   * @param name name of the routine 
   *
   */
   
  public Routine(SoftwareSystem sys, String name)
  { 	
 	super(sys, name);
  }
 
  /** Returns the signature of this routine. This signature is defined by its name
   * 
   * @return signature of this routine
   *
   */
   
  public String getSignature()
  {
  	return getName();
  }
}