/*
 * Created on Jul 21, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.actions;

import java.util.ArrayList;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.dialogs.IInputValidator;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.window.Window;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbenchPart;

import seat.SeatUtil;
import seat.model.core.dynamic.Node;
import seat.ui.tree.viewer.MultiTraceEditor;
import seat.ui.views.ModelView;

/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GroupHideAction extends Action implements IViewUpdater{
	private Object[] hiddenList; // hold nodes to be hidden
	
	public GroupHideAction() {
		// TODO Auto-generated constructor stub
		super("",Action.AS_PUSH_BUTTON);
		setText("Hide Nodes...");
		setToolTipText("Hide Nodes By Specifying the Label");
		setImageDescriptor(SeatUtil.getImageDescriptor("icons/fields_co.gif"));
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		String userSelection=userSelectionDialog("Hide Matched Nodes","Enter the name of nodes to be hidden");
		if (userSelection==null) // canceled
			return;
		IEditorPart activeEditor=SeatUtil.getActiveEditor();
		if (activeEditor instanceof MultiTraceEditor) {
			MultiTraceEditor med=(MultiTraceEditor)activeEditor;
			ArrayList nodes=med.getTrace().getState().getModelNodeList();
			ArrayList hidden=new ArrayList();  // gather hidden list
			for (int i=0;i<nodes.size();i++) {
				Node node=(Node)nodes.get(i);
				if (node.getLabel().indexOf(userSelection)!=-1) {
					node.hide(SeatUtil.RESERVED_ALGIDX_FILTER);
					hidden.add(node);
				}
			}
			hiddenList=hidden.toArray();
			if (hiddenList.length<1) { 
				SeatUtil.showMessage("No matches found!");
				return;
			}
			
			med.refresh();
			updateView(SeatUtil.VIEW_MODEL,true);								
		} else {
			SeatUtil.showMessage("The current active editor is not a trace!");
		}
	}
	public static  String userSelectionDialog(String title, String msg) {
		IInputValidator validator=new IInputValidator() {
			public String isValid(String newText) {
				if ((newText==null)||(newText.length()==0))
					return new String("Please enter a non-empty search string!");
				else
					return null; // null for ok
			}
		};
		InputDialog level=new InputDialog(null,title,msg,"",validator);
		if (level.open()==Window.OK) {
			return level.getValue();
		} else
			return null;
	}
	/* (non-Javadoc)
	 * @see seat.ui.views.IViewUpdater#updateView(java.lang.String, boolean)
	 */
	public void updateView(String viewId, boolean makeViewCurrent) {
		// TODO Auto-generated method stub
		IViewPart view;
		if (makeViewCurrent)
			view=SeatUtil.switchToView(viewId);
		else 
			view=SeatUtil.findView(viewId);
		if (view==null)
			return;
			
		if (view instanceof ModelView) {
			ModelView mod=(ModelView)view;
			mod.partActivated((IWorkbenchPart)SeatUtil.getActiveEditor());		
			mod.hideUserSelectedNodes(hiddenList);
		}		
		
	}

}
