/*
 * Created on Jun 18, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbenchPart;

import seat.SeatPlugin;
import seat.SeatUtil;
import seat.model.core.dynamic.Node;
import seat.ui.tree.partial.TreeNode;
import seat.ui.tree.viewer.TraceEditorPage;
import seat.ui.views.ModelView;

public class HideAction extends TraceEditorAction implements IViewUpdater{
	private Node[] nodes;  // holds selected nodes
	public HideAction(TraceEditorPage edit) {
		// TODO Auto-generated constructor stub
		super(edit,Action.AS_CHECK_BOX);
		setText("Hide");
		setToolTipText("Hide Selected Nodes");
		setImageDescriptor(SeatPlugin.getImageDescriptor(SeatUtil.ICON_FILTER));
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		Viewer viewer=page.getViewer();
		IStructuredSelection selection=(IStructuredSelection)viewer.getSelection();
		TreeNode[] paths=new TreeNode[selection.size()];
		paths=(TreeNode[])selection.toList().toArray(paths);
		nodes=new Node[paths.length];
		for (int i=0;i<paths.length;i++) {
			nodes[i]=paths[i].getElement();
			page.getExploration().cacheNodeContext(paths[i],SeatUtil.RESERVED_ALGIDX_FILTER,this.isChecked());
		}
 
 		page.getMultiPageEditor().refresh();
 		updateView(SeatUtil.VIEW_MODEL,true);
	}
	
	/* (non-Javadoc)
	 * @see seat.ui.views.IViewUpdater#updateView(java.lang.String, boolean)
	 */
	public void updateView(String viewId, boolean makeViewCurrent) {
		// TODO Auto-generated method stub
		IViewPart view;
		if (makeViewCurrent)
			view=SeatUtil.switchToView(viewId);
		else 
			view=SeatUtil.findView(viewId);
		if (view==null)
			return;

		if (view instanceof ModelView) {
			ModelView model=(ModelView)view;
			model.partActivated((IWorkbenchPart)page);		
			if (this.isChecked())
				model.hideUserSelectedNodes(nodes);
			else
				model.showUserSelectedNodes(nodes);			
		}				
	}

}	