package seat.ui.algorithm;

import seat.SeatPlugin;

/**
 * Conveneice class to represent several algorithm as a whole.
 * Status of each algorithm that if it's applied to given trace
 * is also recorded inside.
 */
public class AlgorithmList {
	AlgorithmDescription[] descriptions;
	boolean[] status;   // status(applied to current trace or not)
	/**
	 * 
	 */
	public AlgorithmList() {
		super();
		// TODO Auto-generated constructor stub
		descriptions=SeatPlugin.getAlgorithmDescriptions();
		status=new boolean[descriptions.length];
		for (int i=0;i<status.length;i++)
			status[i]=false;
	}
	

//	public static AlgorithmDescription getAlgorithmDescription(String index) {
//		AlgorithmDescription[] ads=SeatPlugin.getAlgorithmDescriptions();
//		for (int i=0;i<ads.length;i++) {
//			if (ads[i].getIndex().equals(index))
//				return ads[i];
//		}
//		return null; 
//	}
	
//	public int getAlgorithmIndex(String id) {
//		for (int i=0;i<descriptions.length;i++) {
//			if (descriptions[i].getID().equals(id))
//				return i;
//		}
//		return -1;
//	}
	
	/**
	 * Finds if an algorithm is applied or not by its unqiue index
	 */
	public boolean getAlgorithmStatus(String index) {
		for (int i=0;i<descriptions.length;i++) {
			if (descriptions[i].getIndex().equals(index))
				return status[i];
		}
		return false;
	}

	/**
	 * Sets state of an given algorithm.
	 * @param index: unique algorithm index
	 * @param stat: boolean-applied or not
	 */
	public void setAlgorithmStatus(String index,boolean stat) {
		for (int i=0;i<descriptions.length;i++) {
			if (descriptions[i].getIndex().equals(index))
				status[i]=stat;
		}
	}

}
