package seat.ui.algorithm;

import seat.ui.actions.AlgorithmAction;

/**
 * This interface is to be used by an algorithm that needs special
 * preprocessing and/or post-processing. These special processing class
 * SHOULD implement this interface so that it will automatically called
 * by framework. 
 * 
 * Such a class can be used to set some special parameter in preference
 * or provide user a dialog. But the user must decides how these dat
 * are saved and passed to an algorithm.  
 */
public interface IAlgorithmAssistant {
	/**
	 * Main body that does the processing of the implemented class.
	 * @param action- main action that this interface helps.
	 */
	public void run(AlgorithmAction action);
}
