package seat.ui.algorithm;

/**
 * Used for implemetnation of program source parsing, such as Java/C++ parser.
 * Algorithms that need parsing include: ConstructorDestrcutor, Polymorphism
 * and ProvateMethodRemoval for the time being. 
 */
public interface IParser {
	/**
	 * Sets the relations between packages, and between clas and package
	 */
	public void setPackageClassRelation();
	/**
	 * Set class hierarchy, superclasses and subclasses. Used in 
	 * overload and override algorithms(Polymorphism)
	 */
	public void setClassHierarchy();
	
	/**
	 * Tests and sets if a class is only for interface purpose.
	 * This methods should interate all the classes currently used 
	 * and set related ClassElement attributes 
	 *
	 */
	public void setClassIsInterface();

	/**
	 * Sets all methods attributes, mainly booleans inside MethodElemets:
	 * PRIVATE, PUBLIC, STATIC,etc. Algorithms that use these attibutes include
	 * ConsDes,PrivateRemovel.... 
	 *
	 */
	public void setMethodAttribute();	
}
