package seat.ui.algorithm;

import seat.model.core.dynamic.Node;

/**
 * Parses name with pak.pak.Class.doMethed format.
 */
public class NameParser {
	
	/** 
	 * Gets all the package/file name preceding the class names
	 * @param node
	 * @return
	 */
	public static String getLongPckageName(Node node) {
		String fullQualifiedName = node.getLabel();
		int lastDot = fullQualifiedName.lastIndexOf('.');
		if (lastDot == -1) {
			System.out.println(
				"Bad data format for names(no dot): " + fullQualifiedName);
			return "";
		} else {
			//separate
			String qualifier = fullQualifiedName.substring(0, lastDot);
			// pck+class
			lastDot = qualifier.lastIndexOf('.');
			if (lastDot == -1) { // no pckage info
				System.out.println(
					"Bad data format for names(no dot): " + fullQualifiedName);
				return "";
			} else {
				return qualifier.substring(0, lastDot);
			}
		}
	}

	/**
	 * Parses long class name from package.class.method name string.
	 * It includes package name and class name.
	 */
	public static String getLongClassName(Node node) {
		String fullQualifiedName = node.getLabel();
		int lastDot = fullQualifiedName.lastIndexOf('.');
		if (lastDot == -1) {
			System.out.println(
				"Bad data format in java parsing(no dot): "
					+ fullQualifiedName);
			return ""; // bad data 
		} else //separate
			return fullQualifiedName.substring(0, lastDot);
	}

	/**
	 * Parses only class name from package.class.method name string
	 */
	public static String getShortClassName(Node node) {
		String fullQualifiedName = node.getLabel();
		int lastDot = fullQualifiedName.lastIndexOf('.');
		if (lastDot == -1) {
			System.out.println(
				"Bad data format in java parsing(no dot): "
					+ fullQualifiedName);
			return ""; // bad data 
		} else { //separate
			String qualifier = fullQualifiedName.substring(0, lastDot);
			// pck+class
			lastDot = qualifier.lastIndexOf('.');
			if (lastDot == -1) { // no pckage info
				System.out.println(
					"Bad data format for names(no dot): " + fullQualifiedName);
				return "";
			} else {
				return qualifier.substring(lastDot + 1);
			}
		}
	}

	/**
	 *  Parse only classname from pck.Class name string
	 */
	public static String getShortClassName(String qualifier) {
		int lastDot = qualifier.lastIndexOf('.');
		String cn = null;
		if (lastDot == -1) { // no pckage info
			cn = qualifier;
		} else {
			cn = qualifier.substring(lastDot + 1);
		}
		return cn;
	}

	/**
	 * Parses only method name from package.class.method name string
	 */
	public static String getShortMethodName(Node node) {
		String fullQualifiedName = node.getLabel();
		int lastDot = fullQualifiedName.lastIndexOf('.');
		if (lastDot == -1) {
			System.out.println(
				"Bad data format in java parsing(no dot): "
					+ fullQualifiedName);
			return ""; // bad data 
		} else { //separate
			return fullQualifiedName.substring(lastDot + 1);
		}
	}

}
