/*
 * Created on Jul 17, 2003
 * 
 * This is the main page for setting trace preference.
 */
package seat.ui.preference;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.ColorFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.PreferenceConverter;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import seat.SeatPlugin;
import seat.SeatUtil;

/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 * <p>
 * Global trace preference page
 * Reminder: for simple preference, extend FieldEditorPreferencePage;
 * complex(inlude list,tree truct) and fine control, extend PreferencePage 
 */

// All the preference pages SHOULD cache its settings for performance.
// Therefore, a static interface method needs to be implemented: refreshCache(Object update)
// This method will be called for each preference fired events.  

public class TracePreference
	extends FieldEditorPreferencePage
	implements IWorkbenchPreferencePage {
	 	
	public TracePreference() {
		// TODO Auto-generated constructor stub
		super(FieldEditorPreferencePage.GRID);
		setPreferenceStore(SeatPlugin.getDefault().getPreferenceStore());
		setDescription("Global trace settings");
		setDefaultConfig(getPreferenceStore());				
	}
	
	/**
	 * Create different fields for preference settings.
	 */
	protected void createFieldEditors() {	
		addField(new BooleanFieldEditor(SeatUtil.TRACE_SHOWFILTERED,"Show nodes that are filtered by algoirthms",getFieldEditorParent()));		
		addField(new BooleanFieldEditor(SeatUtil.TRACE_SHORTPROPERTY,"Use short property",getFieldEditorParent()));	
		addField(new ColorFieldEditor(SeatUtil.COLOR_FILTER,"Color of hidden nodes",getFieldEditorParent()));		
		addField(new ColorFieldEditor(SeatUtil.COLOR_HIGHTLIGHT,"Color of current selected nodes",getFieldEditorParent()));		
		addField(new ColorFieldEditor(SeatUtil.COLOR_UTILITY,"Color of utility nodes",getFieldEditorParent()));		
		addField(new ColorFieldEditor(SeatUtil.COLOR_PATTERN,"Color of pattern",getFieldEditorParent()));					
	}

	// set the default data when "Restore Defaults" button is pressed
	// also will be called by plugin start to det first			
	public static void setDefaultConfig(IPreferenceStore store) {
		store.setDefault(SeatUtil.TRACE_SHOWFILTERED,true);
		store.setDefault(SeatUtil.TRACE_SHORTPROPERTY,false);
		PreferenceConverter.setDefault(store,SeatUtil.COLOR_FILTER, new RGB(193,223,232));
		PreferenceConverter.setDefault(store,SeatUtil.COLOR_HIGHTLIGHT, new RGB(209,231,171));
		PreferenceConverter.setDefault(store,SeatUtil.COLOR_UTILITY, new RGB(164,211,247));
		PreferenceConverter.setDefault(store,SeatUtil.COLOR_PATTERN, new RGB(218,222,184));
//		store.setDefault(SeatUtil.TRACE_COMPRESS,true);
//		store.setDefault(SeatUtil.TRACE_DIRECTORY,".\\trace");
//		store.setDefault(SeatUtil.TRACE_TMP_DIRECTORY,".\\trace\\tmp");
	}	

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench arg0) {
		// TODO Auto-generated method stub
	}
}
