package seat.ui.tree.partial;

/**
 * This interface is used to implement dynamic tree loading techniques.
 * The get*Tree() methods return the trees(actally the root node) which
 * are dynamically created. A tree is a subtree from model graph, it will
 * be used as the source of UI Tree widget.
 */
public interface IDynamicTree {
	// Gets root node of the tree
	public UniquePath getRoot();
	
	// Gets previous tree (offset -1) from current node
	public UniquePath getPreviousTree(UniquePath currentNode,boolean force);
	
	// Gets next tree (offset 1) from current node
	public UniquePath getNextTree(UniquePath currentNode,boolean force);
	
	// Gets previous tree with given offset from current node
	public UniquePath getPreviousTree(UniquePath currentNode,int offset,boolean force);

	// Gets next tree with given offset from current node
	public UniquePath getNextTree(UniquePath currentNode,int offset,boolean force);
	
	// Sets number of nodes to be included in the tree
	public void setTreeSize(int sizeToBeRetrieved);
}
