
package seat.ui.tree.viewer;

/**
 * This interface is to determine the icon ID for a node.
 * Possible IDs are defined in PictureLabel:
 * NONE,PLUS,MINUS,WAVE 
 */
public interface IExpandProvider {
	/**
	 * Gets the icon ID for a node. The icon is used to draw 
	 * expand/collapse icon of a tree node.  
	 * @param element- elment
	 * @return icon id
	 * @see PictureLabel
	 */
	public int getExpandID(Object element);
}
