package seat.ui.tree.viewer;

import org.eclipse.jface.viewers.Viewer;

import seat.model.core.dynamic.Trace;
import seat.ui.tree.partial.IDynamicTree;

/**
 * Basic interface that ant trace viewer needs to implements.
 */
public interface ITraceViewer {
	/**
	 * Refresh the viewer so new data is displayed.
	 *
	 */
	public void refresh();                // refresh current window
	
	/**
	 * Returns the trace that is associated with this viewer.
	 * @return Trace
	 */
	public Trace getTrace();		      // return trace to be displayed
	
	/**
	 * Returns the dynamic tree that provides model data to the viewer
	 * @return
	 */
	public IDynamicTree getTree();        // model partial tree	
	
	/**
	 * Returns this viewer.
	 * @return
	 */
	public Viewer getViewer();            // construct UI tree	
}
