/*
 * Created on May 21, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.tree.viewer;

import java.util.ArrayList;

import org.eclipse.jface.viewers.IColorProvider;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

import seat.SeatPlugin;
import seat.SeatUtil;
import seat.model.core.dynamic.Node;
import seat.model.core.dynamic.Trace;
import seat.ui.algorithm.NameParser;
import seat.ui.preference.DecorationPreference;
import seat.ui.tree.partial.IDynamicTree;
import seat.ui.tree.partial.PartialTree;
import seat.ui.tree.partial.TreeNode;
import seat.ui.tree.partial.UniquePath;
import seat.ui.tree.widget.PartialTreeViewer;
import seat.ui.tree.widget.PictureLabel;
/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TraceViewer extends PartialTreeViewer implements ITraceViewer {
	protected Exploration exploration;
	protected Trace trace;
	protected IDynamicTree tree;
//	protected Color nodeBackground,defaultBackground; 
	private Node highlightedNode; 
	// colors for color provider
	private static Color white=Display.getCurrent().getSystemColor(SWT.COLOR_WHITE);
	private static Color blue=Display.getCurrent().getSystemColor(SWT.COLOR_BLUE);
	private static Color black=Display.getCurrent().getSystemColor(SWT.COLOR_BLACK);
	private static Color grey=Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY);

	/**
	 * 
	 */
	public TraceViewer(Composite parent, Exploration explore) {
		super(parent);
		// TODO Auto-generated constructor stub
		this.exploration=explore;
		this.trace=explore.getTrace();
		this.tree=constructFromTrace(trace);

		this.setContentProvider(new TreeContentProvider());
		this.setLabelProvider(new TreeLabelProvider());
		this.addDoubleClickListener(new TreeDoubleClickListener(this));
		this.setInput(tree); // need set input to invisble , not starting

//		nodeBackground=new Color(Display.getCurrent(), new RGB(162,216,249));
//		defaultBackground=Display.getCurrent().getSystemColor(SWT.COLOR_WHITE);
//		coloredItems=new ArrayList();
	}
	
	private IDynamicTree constructFromTrace(Trace trace) {
		// TODO Auto-generated method stub		
		String filter=SeatUtil.getStringSetting(SeatUtil.TRACE_SHOWFILTERED);
		boolean includeFiltered=Boolean.valueOf(filter).booleanValue();
		
		PartialTree pt=new PartialTree(trace);		
		pt.setIncludeHidden(includeFiltered);
//		pt.setFilter();
		pt.construct();
		return pt;
	}

	class TreeContentProvider implements IStructuredContentProvider,ITreeContentProvider {
		public void inputChanged(Viewer v, Object oldInput, Object newInput) {
		}
		public void dispose() {
		}
		public Object[] getElements(Object parent) {
			return getChildren(parent);
		}
		public Object getParent(Object child) {
			return ((TreeNode) child).getParent();
		}
		public Object[] getChildren(Object parent) {
			return ((TreeNode) parent).getChildren();
		}
		public boolean hasChildren(Object parent) {
			return ((TreeNode) parent).hasUnhiddenChildren();
		}
	}


//	// Color usage is defined in SeatUtil color section	
//	private static Color[] COLOR;
//	static {
//		COLOR=new Color[9];
//		COLOR[0]=new Color(Display.getCurrent(), new RGB(162,216,249));
//		COLOR[1]=new Color(Display.getCurrent(), new RGB(14,135,207));
//		COLOR[2]=new Color(Display.getCurrent(), new RGB(108,200,120));
//		COLOR[3]=new Color(Display.getCurrent(), new RGB(177,226,184));
//		COLOR[4]=new Color(Display.getCurrent(), new RGB(219,163,45));
//		COLOR[5]=new Color(Display.getCurrent(), new RGB(238,211,157));
//		COLOR[6]=new Color(Display.getCurrent(), new RGB(135,165,180));
//		COLOR[7]=new Color(Display.getCurrent(), new RGB(200,215,221));	
//		COLOR[8]=new Color(Display.getCurrent(), new RGB(204,208,208));	 // gray hidden node
//	}
	class TreeLabelProvider extends LabelProvider implements IColorProvider,IExpandProvider {
//		private Map imageCache = new HashMap(11); // cache for performance

		public String getText(Object obj) {
			TreeNode to=(TreeNode)obj;			
			String decoredName=DecorationPreference.decorate(to.getName(),to.getRepetition(),to.getElement().isHidden(),to.getElement().getState()!=2);
			String className=NameParser.getShortClassName(to.getElement());			
			return decoredName;//decoredName.replaceAll("<init>",className);
		}

		public Image getImage(Object obj) {
			if (obj instanceof TreeNode) {
				TreeNode path=(TreeNode)obj;
				return SeatPlugin.getImage(path.getImageID());

//				// we have get the base image so far
//				ArrayList decors=new ArrayList();
//				decors.add(null); 
//				decors.add(SeatUtil.getImageDescriptor("icons/abstract_co.gif")); 
//				DecoratorOverlayIcon overlayIcon = new DecoratorOverlayIcon(image, decors);
//				Image newImage= (Image)imageCache.get(overlayIcon);
//				if (newImage== null) {
//					newImage= overlayIcon.createImage();
//					imageCache.put(overlayIcon, newImage);
//				}		
//			
//				return newImage;			
			} else
				return null;
		}
		
		// Interface from IColorProvider 
		public Color getForeground(Object element) {
			if (element instanceof TreeNode) {
				TreeNode path=(TreeNode)element;
				String imageID=path.getImageID();  // determine color for image id
				if (imageID.equals(SeatUtil.ICON_FILTER))
					return grey;
			} 
			return black; 			
		}
		public Color getBackground(Object element) {
			if (element instanceof TreeNode) {
				TreeNode path=(TreeNode)element;
				
				// precedence of color:0,selection, 1.highlighted, 2.special, 3.normal
				if (path.getElement()==highlightedNode)
					return SeatPlugin.getColor(SeatUtil.COLOR_HIGHTLIGHT);

				String imageID=path.getImageID();  // determine color for image id
				if (imageID.equals(SeatUtil.ICON_ROOT)||
						imageID.equals(SeatUtil.ICON_COMPOUND)||
						imageID.equals(SeatUtil.ICON_METHOD)) 
					return white;
				else if (imageID.equals(SeatUtil.ICON_FILTER))
					return SeatPlugin.getColor(SeatUtil.COLOR_FILTER);
				else if (imageID.equals(SeatUtil.ICON_PATTERN))
					return SeatPlugin.getColor(SeatUtil.COLOR_PATTERN);
				else if (imageID.equals(SeatUtil.ICON_UTILITY))
					return SeatPlugin.getColor(SeatUtil.COLOR_UTILITY);
				else 
					return white; 
			} else
				return white; 		
		}				 	
		
		// Interface from IExpandProvider
		public int getExpandID(Object element) {
			if ((tree instanceof PartialTree)&&(element instanceof TreeNode)) {
				int expState=((PartialTree)tree).isExpanded((UniquePath)element);
				return (expState!=-1)?expState:(((UniquePath)element).getElement().isLeaf()?PictureLabel.NONE:PictureLabel.PLUS);	
			} else
				return PictureLabel.NONE;
		}
	}
	
	/* (non-Javadoc)
	 * @see seat.ui.viewer.ITraceViewer#getTrace()
	 */
	public Trace getTrace() {
		// TODO Auto-generated method stub
		return trace;
	}

	public IDynamicTree getTree() { // construct UI tree	
		return tree;		
	} 

	/**
	 * Sets image ids for all node elements that is included in the partial tree.
	 */
	protected void setImages() {			
		setImageHelper(tree.getRoot());		
		if (tree instanceof PartialTree) {
			((PartialTree)tree).refreshAllExpansion(false);
		}
	}
  
	/*
	 * A recursive method called by setImages(). Sets all the images for the partial tree. 
	 */ 
	private void setImageHelper(TreeNode node) {
		if (node==null)
			return;
		determineImage(node);
		TreeNode[] children=node.getChildren();
		for (int i=0;i<children.length;i++) {
			setImageHelper(children[i]);
		}
	}	
	
	// THIS IS THE METHOD THAT DETERMINES THE VISUALIZATION OF NODES OF TREE
	// The icon/image of node will be displayed using rule here 
	private void determineImage(TreeNode tn) {
		Node model=tn.getElement();
		if (!model.isHidden()) {
			if (tn.equals(tree.getRoot()))
				tn.setImageID(SeatUtil.ICON_ROOT); 
			else if (tn.getElement().isLeaf())
				tn.setImageID(SeatUtil.ICON_METHOD);
			else  
				tn.setImageID(SeatUtil.ICON_COMPOUND);
				
			// tests if in pattern list
			Node node=tn.getElement();			
			ArrayList pattern=exploration.getPatternList();
			for (int i=0;i<pattern.size();i++)
				if ((Node)pattern.get(i)==node) {
					tn.setImageID(SeatUtil.ICON_PATTERN);
					break;
				}	
											
		} else {
			tn.setImageID(SeatUtil.ICON_FILTER);			
			// Tests if in gobla permant utility list
			String ul=SeatUtil.getStringSetting(SeatUtil.TRACE_UTILITY_METHODLIST);
			if (ul.indexOf(tn.getElement().getLabel())!=-1) {
				tn.setImageID(SeatUtil.ICON_UTILITY);
			}
				
			// tests if in utility list
			ArrayList util=exploration.getUtilityList();
			Node node=tn.getElement();			
			for (int i=0;i<util.size();i++)
				if ((Node)util.get(i)==node) {
					tn.setImageID(SeatUtil.ICON_UTILITY);
					break;
				}
		}
		
//		if (tn.isHidden()) // ui level hiden,like ignore order merge
//			tn.setImageID(SeatUtil.IMG_ALGORITHM1);				
	}
	
	/* (non-Javadoc)
	 * @see seat.ui.tree.viewer.ITraceViewer#getViewer()
	 */
	public Viewer getViewer() {
		// TODO Auto-generated method stub
		return this;
	}

	/**
	 * @return
	 */
	public Exploration getExploration() {
		return exploration;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.Viewer#refresh()
	 */
	public void refresh() {
		// TODO Auto-generated method stub
		super.refresh();
	}

	public void refresh(UniquePath top) {
		// TODO Auto-generated method stub
		super.refresh(top);
	}

	/**
	 * @param node
	 */
	public void setHighlightedNode(Node node) {
		highlightedNode = node;
	}
	
}
