/*
 * Created on Jul 14, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.tree.widget;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.List;

import org.eclipse.jface.viewers.DoubleClickEvent;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseTrackAdapter;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.events.TreeListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.ScrollBar;
import org.eclipse.swt.widgets.TypedListener;

import seat.SeatPlugin;
import seat.SeatUtil;
import seat.ui.tree.partial.PartialTree;
import seat.ui.tree.partial.TreeNode;
import seat.ui.tree.partial.UniquePath;

/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PictureTree extends Canvas {
	ArrayList picLabelList=new ArrayList(); // a list for all visible nodes
	ArrayList invLabelList=new ArrayList(); // a list for all invisible linking parent nodes	
	private PartialTree partialTree;				// partial tree displayed by this widget

	private Image bufferedImage; 					// double buffer for drawing
	private int oldVSelection=0;					// last vertical scrollbar position
	private PictureLabel[] selectedPictureLabel;    // current selection result
	private PictureLabel lastSelection;				// last clicked
	private ArrayList progessedSelection=new ArrayList(); // contains all ctrl+clicks.
	private boolean alwaysRedraw=true;				// overides redraw()
	
	private Color white=Display.getCurrent().getSystemColor(SWT.COLOR_WHITE);
	private Color darkBlue=Display.getCurrent().getSystemColor(SWT.COLOR_DARK_BLUE);
	
	public PictureTree(Composite parent, int style) {
		super(parent, checkStyle(style));
		setBackground(white);
		
		addControlListener(new ControlAdapter() {
			public void controlResized(ControlEvent e) {
				refreshPartialTree(0);
			}
		});	
		addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent e) {
				onPaintControl(e);
			}
		});
		addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				onKeyPressed(e);
			}
		});
		addMouseListener(new MouseAdapter() {
			public void mouseDoubleClick(MouseEvent e) {
				onMouseDoubleClick(e);
			}
			public void mouseDown(MouseEvent e) {
				onMouseDown(e);
			}
		});
		addMouseTrackListener(new MouseTrackAdapter() {
			public void mouseHover(MouseEvent e) {
				onMouseHover(e);
			}
		});
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e){
				onWidgetDisposed();
			}
		});
		initScrollBars();
	}

	public PictureTree(Composite parent, int style,PartialTreeViewer v) {
		this(parent,style);
		setViewer(v);
	}
	
	private static int checkStyle (int style) {
		int mask = SWT.V_SCROLL|SWT.H_SCROLL|SWT.NO_BACKGROUND;
		return style | mask;
	}
	
	private void initScrollBars() {
		ScrollBar horizontal = getHorizontalBar();
		horizontal.setVisible(false);
		horizontal.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent event) {
				scrollHorizontally((ScrollBar) event.widget);
			}
		});
		ScrollBar vertical = getVerticalBar();
		vertical.setVisible(false);
		vertical.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent event) {
				scrollVertically((ScrollBar) event.widget);
			}
		});
	}

	/* Scroll horizontally */
	private void scrollHorizontally(ScrollBar scrollBar) {
		syncScrollBars();
		redraw();
	}

	/* Scroll vertically */
	private void scrollVertically(ScrollBar scrollBar) {
		int newVSelection=scrollBar.getSelection();
		int offset=newVSelection-oldVSelection;
		refreshPartialTree(offset);
		oldVSelection=newVSelection;		
	}


	
	/**
	 * Synchronizes scrolls bars with given vertical offset selection. 
	 * New selection is set only when there is more pages invisible. 
	 * If vselection equals -1, selection is not set and only refresh 
	 * scroll bar maximum and thumb size.  
	 * @param offsetFromRoot: -1 : No new selection is set.
	 * 					Otherwise, offset of current top from root
	 */
	private void syncScrollBars(int offsetFromRoot) {
		ScrollBar vertical = getVerticalBar();
		int totalNodes=getTreeSize();
		int visNodes=getWindowItemCount();
		vertical.setIncrement(1);
		vertical.setPageIncrement(visNodes);
		if (totalNodes>visNodes) { // show bar
			vertical.setMaximum(totalNodes);  
			vertical.setEnabled(true);			
			vertical.setVisible(true);			
			vertical.setThumb(visNodes);
			if (offsetFromRoot!=-1) {  // will set
				if (totalNodes-offsetFromRoot>visNodes) // set real offset
					vertical.setSelection(offsetFromRoot);
				else
					vertical.setSelection(totalNodes-visNodes);  // set last availible position
				oldVSelection=vertical.getSelection();
			}
		} else {
			vertical.setEnabled(false);			
			vertical.setVisible(false);			
		}

//		prin(offsetFromRoot);	

	
		ScrollBar horizontal= getHorizontalBar();
		horizontal.setIncrement((int) (getClientArea().height/ 100));
		horizontal.setPageIncrement(getClientArea().height);
		int maxWidth=getMaxItemWidth();
		int visWidth=getClientArea().width;
		if (maxWidth>visWidth) { // show bar
			horizontal.setMaximum(maxWidth); // 0-n-1
			horizontal.setEnabled(true);			
			horizontal.setVisible(true);			
			horizontal.setThumb(visWidth);
		} else {
			horizontal.setEnabled(false);			
			horizontal.setVisible(false);			
		}	
	}
	

	private void onPaintControl(PaintEvent event) {
		Rectangle rectClient = getClientArea();
		if (rectClient.width == 0 || rectClient.height == 0) return;

		GC gc = event.gc;

		if (partialTree==null) {
			gc.setClipping(rectClient);
			gc.fillRectangle(rectClient);
			initScrollBars();
			return;
		}
					
		if (bufferedImage != null){bufferedImage.dispose();}
		int width=getMaxItemWidth();
		if (width<rectClient.width)
			width=rectClient.width;	
		Rectangle rectTree=new Rectangle(rectClient.x,rectClient.y,width,rectClient.height);
		bufferedImage = new Image( getDisplay(),rectTree.width, rectTree.height);
		GC newGC = new GC(bufferedImage);
		newGC.setClipping(rectTree);

		// set color for selection;
		setSelectionColor(white,darkBlue);

		for (int i=0;i<picLabelList.size();i++) {		
			PictureLabel pl=(PictureLabel)picLabelList.get(i);			
			drawPictureLabel(newGC,pl); // draw this label
			drawConnectionLine(newGC,pl); //draw connection line
		}
		for (int i=0;i<invLabelList.size();i++) {
			PictureLabel pl=(PictureLabel)invLabelList.get(i);						
			drawConnectionLine(newGC,pl); //draw connection line
		}		
		newGC.dispose();
		int hx=0;
		if (getHorizontalBar().isVisible())
			hx=getHorizontalBar().getSelection();
		try {
			gc.drawImage(bufferedImage,hx,0,rectClient.width,rectClient.height,0,0,rectClient.width,rectClient.height);
		} catch (IllegalArgumentException  ie) {
			System.out.println("hx"+hx+"rect:"+rectClient.width+"h:"+rectClient.height);
			if (bufferedImage==null)
				System.out.println("NULL");
		}
	}
	
	private void drawPictureLabel(GC gc, PictureLabel pl) {
		// draw expand icons(+,-,~)
		Rectangle bounds=pl.getExpandBounds();		
		Image expandIcon=pl.getExpandImage();
		if (expandIcon!= null) {
			gc.drawImage(expandIcon, bounds.x, bounds.y); 
		}

		// draw node icon 
		bounds=pl.getImageBounds();		
		Image nodeIcon=pl.getImage();
		if (nodeIcon != null) {
			gc.drawImage(nodeIcon, bounds.x, bounds.y); 
		}

		// draw label
		bounds=pl.getTextBounds();		
		String label=pl.getText();
		if (label!= null) {
			gc.setBackground(pl.getBackground());
			gc.setForeground(pl.getForeground());
			gc.fillRectangle(bounds);//;bounds.x,bounds.y,bounds.width,bounds.height);
			gc.drawString(label, bounds.x, bounds.y);
		}  
	}
	
	/*
	 * Draws a dotted connection line from the given lable to its next neighbor.
	 * If it does not have a such a neighbor, nothing is drawn; Or the next neigbor
	 * is out of drawing area, only draws to the edge of client area.
	 *   
	 * @param gc
	 * @param pl
	 */
	private void drawConnectionLine(GC gc, PictureLabel pl) {
		int x,y1,y2;
		Rectangle bound=pl.getExpandBounds();
		// find a sibling
		int index=picLabelList.indexOf(pl);
		if (index==-1) { // pl is is invisible list
			x=bound.x+bound.width/2-1;
			y1=0;
		} else {
			x=bound.x+bound.width/2-1;
			y1=(pl.getExpandId()==PictureLabel.NONE)?bound.y:bound.y+bound.height-2;
		}
		
		boolean hasSibling=false;
		PictureLabel sib=null;
		for (int j=index+1;j<picLabelList.size();j++) {
			sib=(PictureLabel)picLabelList.get(j);
			if (pl.getLevel()>sib.getLevel()) // exit subtree, break 
				break;
			else if (pl.getLevel()==sib.getLevel()) {
				hasSibling=true;
				break;
			}
		}
		
		// draw line to this sibling 
		if (hasSibling)   
			y2=sib.getExpandBounds().y;
		else if (partialTree.hasMoreSilbingToShow((UniquePath)pl.getData()))
			y2=getClientArea().height; // till bottom
		else 
			y2=y1; 
		gc.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
		if (y1>y2) {
			int temp=y1;
			y1=y2;
			y2=temp;
		}
		for (int y=y1;y<y2;y+=2)
			gc.drawLine(x,y,x,y);		
	}	
	

	private void onWidgetDisposed() {
	}

	private void onKeyPressed(KeyEvent e) {
		ScrollBar vertical=getVerticalBar();
		if (vertical==null)
			return;
		int index=getItemIndex(lastSelection);
		if (index==-1) 
			index=0;
			
		switch (e.keyCode) {
			case SWT.ARROW_DOWN:					
				if (index==picLabelList.size()-1) { // keep the index
					if (vertical.getSelection()+1<=vertical.getMaximum())
						vertical.setSelection(vertical.getSelection()+1);
					scrollVertically(vertical);
				} else if (index+1<=picLabelList.size()-1)  // inc index
					index++;
				setSelection((PictureLabel)picLabelList.get(index));
//				System.out.println("Arrow down: "+((PictureLabel)picLabelList.get(index)).getText());
				return;
			case SWT.PAGE_DOWN:					
				if (vertical.getSelection()+vertical.getPageIncrement()<=vertical.getMaximum())
					vertical.setSelection(vertical.getSelection()+vertical.getPageIncrement());
				else
					vertical.setSelection(vertical.getMaximum());
				scrollVertically(vertical);

				setSelection((PictureLabel)picLabelList.get(index));
				return;
			case SWT.END:					
				vertical.setSelection(vertical.getMaximum());
				scrollVertically(vertical);

				setSelection((PictureLabel)picLabelList.get(picLabelList.size()-1));
				return;
			case SWT.ARROW_UP:					
				if (index==0) { // keep the index
					if (vertical.getSelection()-1>=vertical.getMinimum())
						vertical.setSelection(vertical.getSelection()-1);
					scrollVertically(vertical);
				} else if (index-1>=0)  // dec index
					index--;
				setSelection((PictureLabel)picLabelList.get(index));
				return;			
			case SWT.PAGE_UP:					
				if (vertical.getSelection()-vertical.getPageIncrement()>=vertical.getMinimum())
					vertical.setSelection(vertical.getSelection()-vertical.getPageIncrement());
				else
					vertical.setSelection(vertical.getMinimum());				
				scrollVertically(vertical);

				setSelection((PictureLabel)picLabelList.get(index));
				return;
			case SWT.HOME:					
				vertical.setSelection(vertical.getMinimum());
				scrollVertically(vertical);

				setSelection((PictureLabel)picLabelList.get(0));
				return;
			case SWT.ARROW_LEFT:
				switch (lastSelection.getExpandId()) {
					case PictureLabel.NONE:
					case PictureLabel.PLUS:
						PictureLabel parent=isParentShown(lastSelection);
						if (parent!=null) { // parent is currently visible
							setSelection(parent);
						} else {						
							int idx=PartialTree.asList(partialTree.getTreeBetween((UniquePath)lastSelection.getData().getParent(),(UniquePath)lastSelection.getData())).size();
							int unshown=idx-getItemIndex(lastSelection)+1; // 1 for parent
							if (vertical.getSelection()-unshown>=vertical.getMinimum())
								vertical.setSelection(vertical.getSelection()-unshown);
							else
								vertical.setSelection(vertical.getMinimum());				
							scrollVertically(vertical);

							setSelection(isParentShown(lastSelection));
						}							
						return;
					case PictureLabel.MINUS:
					case PictureLabel.WAVE:
//						lastSelection.setExpandIcon(PictureLabel.PLUS);
						UniquePath selected=(UniquePath)lastSelection.getData();
						((PartialTree)partialTree).removeFromExpandSet(selected);
						refreshPartialTree(0);
						return;									
					}
			case SWT.ARROW_RIGHT:
				switch (lastSelection.getExpandId()) {
					case PictureLabel.PLUS:
//						lastSelection.setExpandIcon(PictureLabel.MINUS);
						UniquePath selected=(UniquePath)lastSelection.getData();
						((PartialTree)partialTree).addToExpandSet(selected);
						refreshPartialTree(0);
						return;									
					case PictureLabel.MINUS:
					case PictureLabel.WAVE:
						index=getItemIndex(lastSelection);
						if (index==picLabelList.size()-1) { // keep the index
							if (vertical.getSelection()+1<=vertical.getMaximum())
								vertical.setSelection(vertical.getSelection()+1);
							scrollVertically(vertical);
						} else if (index+1<=picLabelList.size()-1)  // inc index
							index++;
						setSelection((PictureLabel)picLabelList.get(index));
						return;
					}
		}
		if (e.keyCode==8) { // bs
			PictureLabel parent=isParentShown(lastSelection);
			if (parent!=null) { // parent is currently visible
				setSelection(parent);
			} else {						
				int idx=PartialTree.asList(partialTree.getTreeBetween((UniquePath)lastSelection.getData().getParent(),(UniquePath)lastSelection.getData())).size();
				int unshown=idx-getItemIndex(lastSelection)+1; // 1 for parent
				if (vertical.getSelection()-unshown>=vertical.getMinimum())
					vertical.setSelection(vertical.getSelection()-unshown);
				else
					vertical.setSelection(vertical.getMinimum());				
				scrollVertically(vertical);

				setSelection(isParentShown(lastSelection));
			}							
			return;
		}
	}
	
	/**
	 * Adds a listener for double-clicks in this viewer.
	 * Has no effect if an identical listener is already registered.
	 *
	 * @param listener a double-click listener
	 */
	private PartialTreeViewer viewer;
	public void setViewer(PartialTreeViewer v) {
		viewer=v;	
	}

	private void onMouseDoubleClick(MouseEvent event) {
		try {
			PictureLabel pl=getItem(event.x,event.y);
			Rectangle bounds= pl.getTextBounds();
			if (!bounds.contains(event.x,event.y)||(viewer==null))
				return;
			viewer.fireDoubleClick(new DoubleClickEvent(viewer,new StructuredSelection(pl.getData())));
		} catch (IndexOutOfBoundsException iobe) {
		}
	}	
	
	private void onMouseDown(MouseEvent e) {
		try {
			PictureLabel pl=getItem(e.x,e.y);
			if (e.button==1) { // left mouse button
				Rectangle bounds= pl.getExpandBounds();
				if (bounds.contains(e.x,e.y)) {
					int mask=e.stateMask;

					UniquePath selected=(UniquePath)pl.getData();
					boolean all=partialTree.isAllRawChildrenShown(selected);
					int iconId=all?PictureLabel.MINUS:PictureLabel.WAVE;
					switch (pl.getExpandId()) {
						case PictureLabel.PLUS:
							pl.setExpandIcon(iconId);
							partialTree.addToExpandSet(selected,iconId);
//						pl.setExpandIcon(PictureLabel.MINUS);
//						partialTree.addToExpandSet(selected,PictureLabel.MINUS);
							break;
						case PictureLabel.MINUS:					
							if ((mask&SWT.CTRL)!=0) { // ctrl is pressed
								if (selected.hasHiddenRawChildren()) {
									pl.setExpandIcon(PictureLabel.WAVE);	
									partialTree.addToExpandSet(selected,PictureLabel.WAVE);
								}
							} else {
								pl.setExpandIcon(PictureLabel.PLUS);
								((PartialTree)partialTree).removeFromExpandSet(selected);
							}
//						pl.setExpandIcon(PictureLabel.PLUS);
//						((PartialTree)partialTree).removeFromExpandSet(selected);
							break;
						case PictureLabel.WAVE:					
							if ((mask&SWT.CTRL)!=0) { // ctrl is pressed
								pl.setExpandIcon(PictureLabel.MINUS);						
								partialTree.addToExpandSet(selected,PictureLabel.MINUS);
							} else {
								pl.setExpandIcon(PictureLabel.PLUS);
								((PartialTree)partialTree).removeFromExpandSet(selected);
							}
							break;
						default:
							break;										 
					}
				} else {
					Rectangle img= pl.getImageBounds();
					Rectangle text= pl.getTextBounds();			
					if ( img.contains(e.x,e.y)||text.contains(e.x,e.y) ) {
						doMouseSelection(e);
					}
				}
			} else {  // not left mouse, middle or right
				Rectangle img= pl.getImageBounds();
				Rectangle text= pl.getTextBounds();			
				if ( (img.contains(e.x,e.y)||text.contains(e.x,e.y))&&(!progessedSelection.contains(pl))) {
					doMouseSelection(e);
				}				
			}
			refreshPartialTree(0);
		} catch (IndexOutOfBoundsException iobe) {
		}
	}

	private void doMouseSelection(MouseEvent e) {
		PictureLabel pl=getItem(e.x,e.y);		
		int mask=e.stateMask;
		
		
		doMouseSelection(pl,mask);
		

	}
	
	private void doMouseSelection(PictureLabel pl,int mask) {
		if ((mask&SWT.CTRL)!=0) { // ctrl is pressed
			modifySelection(pl);
		} else if ((mask&SWT.SHIFT)!=0) { // shift is pressed
			if (!pl.equals(lastSelection)) {
				TreeNode prev=lastSelection.getData();
				TreeNode current=pl.getData();
				List list=PartialTree.asList(partialTree.getTreeBetween((UniquePath)prev,(UniquePath)current));
				setSelection(createSelection(list,prev.getLineNo()<current.getLineNo()?prev:current));
			}
		} else {
//			if (!pl.equals(lastSelection)) {
				setSelection(pl);  // set only current one
//			}
						
		}
	}


	private void modifySelection(PictureLabel pl) {
		if (!SeatUtil.removeIfInside(pl,progessedSelection)) 
			progessedSelection.add(pl);
		selectedPictureLabel=(PictureLabel[])progessedSelection.toArray(new PictureLabel[progessedSelection.size()]);
		Comparator compare=new Comparator() {
			public int compare(Object o1, Object o2) {
				if (!(o1 instanceof PictureLabel)||(!(o1 instanceof PictureLabel)) )
					return 0;
				else {
					PictureLabel pl1=(PictureLabel)o1; 
					PictureLabel pl2=(PictureLabel)o2;
					return ((TreeNode)pl1.getData()).getLineNo()-((TreeNode)pl1.getData()).getLineNo();
				}
			}
		};
		Arrays.sort(selectedPictureLabel,compare);
		lastSelection=pl;
	}
	 
	private void onMouseHover(MouseEvent e) {
		Rectangle client=getClientArea();
		if (!client.contains(e.x,e.y))
			return;
		try {
			PictureLabel pl=getItem(e.x,e.y);
			if (pl==null)
				return;
			Rectangle bounds= pl.getExpandBounds();
			Rectangle text= pl.getTextBounds();			
			if (bounds.contains(e.x,e.y)) 
				setToolTipText("Click to expand,Ctrl+Click to switch");
			else if (getHorizontalBar().isVisible()&&text.contains(e.x,e.y)&&pl.getBounds().width>getClientArea().width ) 
				setToolTipText(pl.getText());
			else
				setToolTipText(null);
		} catch (IndexOutOfBoundsException iobe) {}
	}

	/**
	 * Creates all the PictureLabels to be displayed. It also
	 * determines the icon id of the each node.
	 * @param nodeList
	 */
	private void createPictureLabels(List nodeList) {
		picLabelList.clear();
		invLabelList.clear();
			
		if (nodeList.size()==0)
			return ;
		
		Image im=SeatPlugin.getImage(SeatUtil.ICON_METHOD);
		//Image im;
		int starting=nodeList.indexOf(partialTree.getTop4NextRound());
		if (starting==-1)
			starting=0;
		for (int i=0;i<nodeList.size();i++) {		
			TreeNode tn=(TreeNode)nodeList.get(i);
			int expState=partialTree.isExpanded((UniquePath)tn);
			int expId;
			if (expState!=-1)
				expId=expState;
			else
				expId=tn.getElement().isLeaf()?PictureLabel.NONE:PictureLabel.PLUS;	
			if (i<starting) { // set all inv label in row 0	
				PictureLabel next=new PictureLabel(this,expId,im,tn.getName(),tn.getLevelOfCall(),0);
				next.setData(tn);
				invLabelList.add(next);
			} else {
				PictureLabel next=new PictureLabel(this,expId,im,tn.getName(),tn.getLevelOfCall(),i-starting);
				next.setData(tn);
				picLabelList.add(next);
			}				
		}
		redraw();
	}
	
	
	private void setSelectionColor(Color foreground,Color background) {
		if ((viewer!=null)&&(viewer instanceof PartialTreeViewer)) 
			((PartialTreeViewer)viewer).determineAppearance();		

		if (picLabelList.size()<=0)
			return;
		if (selectedPictureLabel==null)
			setSelection((PictureLabel)picLabelList.get(0));
		for (int i=0;i<picLabelList.size();i++) {
			PictureLabel pl=(PictureLabel)picLabelList.get(i);
			boolean inside=false;
			for (int j=0;j<selectedPictureLabel.length;j++)
				if (pl.equals(selectedPictureLabel[j])) {
					inside=true;
					break;
				}
			if (inside) {
				pl.setForeground(foreground);
				pl.setBackground(background);
			} 
		}
	}	

	private PictureLabel[] createSelection(List nodeList,TreeNode first) {
		ArrayList labels=new ArrayList();
		if (nodeList.size()==0)
			return (PictureLabel[])labels.toArray(new PictureLabel[labels.size()]);
		
		Image im=SeatPlugin.getImage(SeatUtil.ICON_METHOD);
		//Image im;
		int starting=nodeList.indexOf(first);
		if (starting==-1)
			starting=0;
		for (int i=starting;i<nodeList.size();i++) {		
			TreeNode tn=(TreeNode)nodeList.get(i);
			int expState=partialTree.isExpanded((UniquePath)tn);
			int expId;
			if (expState!=-1)
				expId=expState;
			else
				expId=tn.getElement().isLeaf()?PictureLabel.NONE:PictureLabel.PLUS;	
			PictureLabel next=new PictureLabel(this,expId,im,tn.getName(),tn.getLevelOfCall(),i-starting);
			next.setData(tn);
			labels.add(next);
		}
		return (PictureLabel[])labels.toArray(new PictureLabel[labels.size()]);
	}


	public PictureLabel isParentShown(PictureLabel item) {
		TreeNode parentModel=item.getData().getParent();
		for (int i=0;i<picLabelList.size();i++) {
			PictureLabel pl=(PictureLabel)picLabelList.get(i);
			if (pl.getData().equals(parentModel))
				return pl;
			}
		return null;		
	}	

	public boolean isChildShown(PictureLabel item,PictureLabel child) {
		TreeNode[] childrenModel=item.getData().getChildren();
		TreeNode cm=child.getData();
		boolean found=false;
		for (int i=0;i<childrenModel.length;i++) {
			if (childrenModel[i].equals(cm)) {
				found=true;
				break;
			}
		}
		if (!found)
			return false;
			
		for (int i=0;i<picLabelList.size();i++) {
			PictureLabel pl=(PictureLabel)picLabelList.get(i);
			if (pl.equals(child))
				return true;
		}
		return false;		
	}
			
	public void setPartialTree(PartialTree tree) {
		partialTree=tree;
		partialTree.loadingStartup(getWindowItemCount());
		createPictureLabels(partialTree.asList());
		syncScrollBars();
	}
	
	public PartialTree getPartialTree() {
		return partialTree;
	}
	
	// actual number of nodes in partial tree
	// used to calc scroll bar position
	public int getTreeSize() {
		return (partialTree==null)?0:partialTree.getWholeTreeSize();
	}		
	
	public void refreshPartialTree(int offset) {
		if (partialTree==null) 
			return;
		partialTree.setTreeSize(getWindowItemCount());
		if (offset>=0)
			partialTree.getNextTree(partialTree.getTop4NextRound(),offset,true);
		else
			partialTree.getPreviousTree(partialTree.getTop4NextRound(),-offset,true);
		createPictureLabels(partialTree.asList());
		syncScrollBars();
	}
	
	public void refreshPartialTree(TreeNode top) {
		if (partialTree==null) 
			return;
		top.setTrace(partialTree.getTrace());
		partialTree.setLoadingPoint((UniquePath)top);
		partialTree.setTreeSize(getWindowItemCount());
		partialTree.getNextTree((UniquePath)top,0,true);
		
		// Modified a bit so five more nodes are visible, NOte: pay attention to correct method name and offset!
		partialTree.getPreviousTree(partialTree.getTop4NextRound(),5,true);
		
		createPictureLabels(partialTree.asList());
		int totalOffset=partialTree.getOffsetFromRoot(partialTree.getTop4NextRound());
		syncScrollBars(totalOffset);	
	}

	private void prin(int root) {
		ScrollBar vertical = getVerticalBar();
		if (vertical.isVisible()) {
			System.out.println(" TreeSize:"+getTreeSize()+"   offest from root:"+ root+"   Scroll Pos:"+vertical.getSelection()+"  First: "+partialTree.getTop4NextRound().getName());
		} else 
			System.out.println("Bar Inv: "+ " Offest from Root:"+root);
	}

		private void syncScrollBars() {
			syncScrollBars(-1);
		}
// public interface			
   
   public void addSelectionListener(SelectionListener listener) {
	   checkWidget ();
	   if (listener == null) return;
	   TypedListener typedListener = new TypedListener (listener);
	   addListener (SWT.Selection, typedListener);
	   addListener (SWT.DefaultSelection, typedListener);
   }
   
   public void addTreeListener(TreeListener listener) {
	   checkWidget ();
	   if (listener == null) return;
	   TypedListener typedListener = new TypedListener (listener);
	   addListener (SWT.Expand, typedListener);
	   addListener (SWT.Collapse, typedListener);
   } 
   // in pixel
   public int getMaxItemWidth() {
	   int max=0;
	   for (int i=0;i<picLabelList.size();i++) {
		   Rectangle bounds=((PictureLabel)picLabelList.get(i)).getBounds();
		   int w=bounds.x+bounds.width;
		   if (w>max)
			   max=w;
	   }
	   return max+10; // 10 for extra space
   }
	


	// Thjere is in index !STACK 0
//	java.lang.ArrayIndexOutOfBoundsException: -1
//		at java.util.ArrayList.get(ArrayList.java:326)
//		at seat.ui.tree.widget.PictureTree.getItem(PictureTree.java:740)
//		at seat.ui.tree.widget.PictureTree.onMouseHover(PictureTree.java:541)
//		at seat.ui.tree.widget.PictureTree.access$4(PictureTree.java:540)
//		at seat.ui.tree.widget.PictureTree$5.mouseHover(PictureTree.java:98)
	public PictureLabel getItem(int x,int y) throws ArrayIndexOutOfBoundsException{
		int index=y/PictureLabel.ICONSIZE;
		return (PictureLabel)picLabelList.get(index);
	}
	
	public PictureLabel getItem(Point point) {
		return getItem(point.x,point.y);
	}
	
	// only nodes in the current window
	public int getWindowItemCount() {
		return getClientArea().height/PictureLabel.ICONSIZE;
	}	
	
	public int getItemHeight() {
		return PictureLabel.ICONSIZE;
	}
	
	public PictureLabel getTopItem() {
		return null;
	}
	public PictureLabel[] getSelection() {
		return selectedPictureLabel;
	}

	public int getSelectionCount() {
		return selectedPictureLabel.length;
	}

	public void setTopItem(PictureLabel top) {
		return ;
	}
	public void setSelection(PictureLabel[] selection) {
		if ((selection!=null)&&(selection.length>0)) {
			selectedPictureLabel=selection;
			if (selection.length==1) {
				lastSelection=selection[selection.length-1];
				if (viewer!=null)
					viewer.fireSelectionChanged(new SelectionChangedEvent(viewer,new StructuredSelection(lastSelection.getData())));					
			}
			progessedSelection.clear();
			for (int i=0;i<selectedPictureLabel.length;i++)
				progessedSelection.add(selectedPictureLabel[i]);
		}
		redraw();
		return ;
	}

	public void setSelection(PictureLabel selection) {
		if (selection!=null)
			setSelection(new PictureLabel[] {selection});
		return ;
	}
	
	public int getItemIndex(PictureLabel item) {
		for (int i=0;i<picLabelList.size();i++) {
			PictureLabel pl=(PictureLabel)picLabelList.get(i);
			if (pl.equals(item))
				return i;
			}
		return -1;
	}
	


	/* (non-Javadoc)
	 * @see org.eclipse.swt.widgets.Control#redraw()
	 */
	public void redraw() {
		// TODO Auto-generated method stub
		if (alwaysRedraw) {
			super.redraw();
			// Note: for bug of continously press a key
			// we need to repaint with each tree load to reflect changes.
			update(); 
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.widgets.Control#setRedraw(boolean)
	 */
	public void setRedraw(boolean redraw) {
		// TODO Auto-generated method stub
		alwaysRedraw=redraw;
		super.setRedraw(redraw);
	}

}
