/*
 * Created on Jul 11, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package seat.ui.views;

import java.util.ArrayList;
import java.util.Arrays;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.PropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;

import seat.SeatUtil;
import seat.io.TraceState;
import seat.model.core.dynamic.Node;
import seat.model.core.structure.ClassElement;
import seat.model.core.structure.LogicalPackage;
import seat.ui.tree.partial.TreeNode;

/**
 * This class is used to add system property capability.
 * To make this attribute works, add the following line to the ViewPart
 * createPartControl() that provides the attributes:
 * 		getSite().setSelectionProvider(viewer);
 * @author lfu
 * @see UniquePath
 */
public class MethodPropertySource implements IPropertySource {
	// property for tracde level
	public static final String PROPERTY_TRACE_NODES="prop.trace_nodes";	
	public static final String PROPERTY_TRACE_GRAPH="prop.trace_graph";	
	public static final String PROPERTY_TRACE_COMPRESSED="prop.trace_compressed";	
	public static final String PROPERTY_TRACE_LOADTIME="prop.trace_loadtime";	
	public static final String PROPERTY_TRACE_PATTERNS="prop.trace_patterns";	
	public static final String PROPERTY_TRACE_SOURCE="prop.trace_source";	
	public static final String PROPERTY_TRACE_TYPE="prop.trace_type";	
	public static final String PROPERTY_TRACE_PACKAGE="prop.trace_package";	
	public static final String PROPERTY_TRACE_CLASS="prop.trace_class";	

	// property for method level
	public static final String PROPERTY_NAME="prop.method_name";
	public static final String PROPERTY_FULLNAME="prop.method_fullname";
	public static final String PROPERTY_TYPE="prop.method_type";
	public static final String PROPERTY_NPARENTS="prop.nparents_type";
	public static final String PROPERTY_NCHILDREN="prop.nchildren";
	public static final String PROPERTY_SCOPE="prop.method_scope";
	public static final String PROPERTY_PARENT="prop.method_parent";
	public static final String PROPERTY_CHILDREN="prop.method_children";
	public static final String PROPERTY_LEVEL="prop.method_level";		
	public static final String PROPERTY_LINENO="prop.method_lineno";		
	public static final String PROPERTY_DESCRIPTION="prop.method_decription";
	
	private IPropertyDescriptor[] propertyDescriptors;
	private TreeNode path;
	
	private static String[] pls;
	private static String[] cls;
	
	private static boolean shortOrLong=SeatUtil.getBooleanSetting(SeatUtil.TRACE_SHORTPROPERTY);
	/**
	 * Constructor. Use UniquePath as the source input of property page
	 * @see org.eclipse.ui.views.properties.IPropertySource#getPropertyDescriptors()
	 */
	public MethodPropertySource(TreeNode source){
		path=source;
		if (path.getTrace()!=null) {
			ArrayList plu=path.getTrace().getState().getPackageList();
			pls=new String[plu.size()];
			for (int i=0;i<pls.length;i++)
				pls[i]=((LogicalPackage)plu.get(i)).getName();
			Arrays.sort(pls);
			ArrayList clu=path.getTrace().getState().getClassList();
			cls=new String[clu.size()];
			for (int i=0;i<cls.length;i++)
				cls[i]=((ClassElement)clu.get(i)).getName();
//			cls=(String[])clu.toArray(new String[clu.size()]);
			Arrays.sort(cls);
		}
}

	/**
	 * Returns editable value for a property
	 * @see org.eclipse.ui.views.properties.IPropertySource#getEditableValue()
	 */
	public Object getEditableValue() {
		// TODO Auto-generated method stub
		return this;
	}

	/**
	 * Creates descriptors for all the property
	 */
	public IPropertyDescriptor[] getPropertyDescriptors() {
		// TODO Auto-generated method stub
		if ((propertyDescriptors==null)||(shortOrLong!=SeatUtil.getBooleanSetting(SeatUtil.TRACE_SHORTPROPERTY))) {			
			
			PropertyDescriptor traceNodes=new PropertyDescriptor(PROPERTY_TRACE_NODES,"1. Total Nodes");
			PropertyDescriptor traceGraph=new PropertyDescriptor(PROPERTY_TRACE_GRAPH,"2. Distinct Nodes");
			PropertyDescriptor traceCompressed=new PropertyDescriptor(PROPERTY_TRACE_COMPRESSED,"3. Hidden Nodes");
			PropertyDescriptor tracePatterns=new PropertyDescriptor(PROPERTY_TRACE_PATTERNS,"4. Pattern Detected");
			PropertyDescriptor traceSource=new PropertyDescriptor(PROPERTY_TRACE_SOURCE,"5. Trace Source");
			PropertyDescriptor traceType=new PropertyDescriptor(PROPERTY_TRACE_TYPE,"6. Tace Type");
			PropertyDescriptor tracePackage=new PropertyDescriptor(PROPERTY_TRACE_PACKAGE,"7. Total Packages");
			PropertyDescriptor traceClass=new PropertyDescriptor(PROPERTY_TRACE_CLASS,"8. Total classes");
			PropertyDescriptor traceLoad=new PropertyDescriptor(PROPERTY_TRACE_LOADTIME,"9. Loading Time");
			traceNodes.setCategory("Trace Statistics");
			traceGraph.setCategory("Trace Statistics");
			traceCompressed.setCategory("Trace Statistics");
			traceLoad.setCategory("Trace Statistics");
			tracePatterns.setCategory("Trace Statistics");
			traceSource.setCategory("Trace Statistics");
			traceType.setCategory("Trace Statistics");
			tracePackage.setCategory("Trace Statistics");
			traceClass.setCategory("Trace Statistics");
// Disabled			
//			PropertyDescriptor[] pckList=null;
//			PropertyDescriptor[] clList=null;;
//			if (path.getTrace()!=null) {
//				pckList=new PropertyDescriptor[pls.length];
//				int len=(pls.length+"").length();
//				for (int i=0;i<pls.length;i++) {
//					int il=(""+(i+1)).length();
//					String id="";
//					for (int k=0;k<len-il;k++)
//						id+="0";
//					id+=(i+1);
//					pckList[i]=new PropertyDescriptor(pls[i],"");// used to be index: id);
//					pckList[i].setCategory("Package List");
//				}
//				clList=new PropertyDescriptor[cls.length];
//				len=(cls.length+"").length();
//				for (int i=0;i<cls.length;i++) {
//					int il=(""+(i+1)).length();
//					String id="";
//					for (int k=0;k<len-il;k++)
//						id+="0";
//					id+=(i+1);
//					clList[i]=new PropertyDescriptor(cls[i],"");//// used to be index: id);id);
//					clList[i].setCategory("Class List");
//				}
//			}
			
			PropertyDescriptor name=new PropertyDescriptor(PROPERTY_NAME,"1. Method Name");
			PropertyDescriptor fullname=new PropertyDescriptor(PROPERTY_FULLNAME,"2. Full Qualified Name");
//			PropertyDescriptor type=new PropertyDescriptor(PROPERTY_TYPE,"Type");		
			PropertyDescriptor nparents=new PropertyDescriptor(PROPERTY_NPARENTS,"3. Called By");		
			PropertyDescriptor nchildren=new PropertyDescriptor(PROPERTY_NCHILDREN,"4. Calls");		
//			PropertyDescriptor scope=new PropertyDescriptor(PROPERTY_SCOPE,"Scope");		
			PropertyDescriptor parent=new PropertyDescriptor(PROPERTY_PARENT,"5. Parent Method");		
//			PropertyDescriptor children=new PropertyDescriptor(PROPERTY_CHILDREN,"Number of Direct Children");		
			PropertyDescriptor level=new PropertyDescriptor(PROPERTY_LEVEL,"6. Level");		
			PropertyDescriptor lineNo=new TextPropertyDescriptor(PROPERTY_LINENO,"7. Trace Line No.");		
			PropertyDescriptor description=new TextPropertyDescriptor(PROPERTY_DESCRIPTION,"8. Source Code Comments");		
			name.setCategory("Current Node");
			fullname.setCategory("Current Node");
//			type.setCategory("Current Node");
			nparents.setCategory("Current Node");
			nchildren.setCategory("Current Node");
//			scope.setCategory("Current Node");
			parent.setCategory("Current Node");
//			children.setCategory("Current Node");
			level.setCategory("Current Node");
			lineNo.setCategory("Current Node");
			description.setCategory("Current Node");
			
//			propertyDescriptors=new IPropertyDescriptor[] {
//				traceNodes,traceGraph,traceCompressed,traceLoad,tracePatterns,traceSource,traceType,tracePackage,traceClass,name,fullname,type,scope,parent,children,level,description };
			ArrayList pds=new ArrayList();
			shortOrLong=SeatUtil.getBooleanSetting(SeatUtil.TRACE_SHORTPROPERTY);
			if (shortOrLong) {
				pds.add(name);
				pds.add(fullname);
//				pds.add(type);
				pds.add(nparents);
				pds.add(nchildren);
//				pds.add(scope);
				pds.add(parent);
//				pds.add(children);
				pds.add(level);
				pds.add(lineNo);
				pds.add(description);				
			} else { 
			pds.add(traceNodes);
			pds.add(traceGraph);
			pds.add(traceCompressed);
			pds.add(traceLoad);
			pds.add(tracePatterns);
			pds.add(traceSource);
			pds.add(traceType);
			pds.add(tracePackage);			
			pds.add(traceClass);
//			for (int i=0;i<pckList.length;i++)   //disabled
//				pds.add(pckList[i]);
//			for (int i=0;i<clList.length;i++)
//				pds.add(clList[i]);
			pds.add(name);
			pds.add(fullname);
//			pds.add(type);
			pds.add(nparents);
			pds.add(nchildren);
//			pds.add(scope);
			pds.add(parent);
//			pds.add(children);
			pds.add(level);
			pds.add(lineNo);
			pds.add(description);
		}
			propertyDescriptors=(IPropertyDescriptor[])pds.toArray(new IPropertyDescriptor[pds.size()]);
		}
		return propertyDescriptors;
	}

	/**
	 * Returns a value by proprty id. The value is to be displayed.
	 * @see org.eclipse.ui.views.properties.IPropertySource#getPropertyValue(java.lang.Object)
	 */
	public Object getPropertyValue(Object id) {
//		System.out.println(id.toString());
		if (path.getTrace()!=null) {
			TraceState state=path.getTrace().getState();
			if (id.equals(PROPERTY_TRACE_NODES))
				return state.getTreeNodes()+"";
			if (id.equals(PROPERTY_TRACE_GRAPH))
				return state.getGraphSize()+"";
			if (id.equals(PROPERTY_TRACE_COMPRESSED))
				return state.getCompressedNodes()+"";
			if (id.equals(PROPERTY_TRACE_LOADTIME))
				return state.getLoadTime()+"sec";
			if (id.equals(PROPERTY_TRACE_PATTERNS))
				return state.getDetectedPatterns()+"";
			if (id.equals(PROPERTY_TRACE_SOURCE))
				return state.getSource().getName();
			if (id.equals(PROPERTY_TRACE_TYPE)) {
				int type=state.getType();
				switch (type) {
					case SeatUtil.TRACE_C:
						return "C";
					case SeatUtil.TRACE_JAVA:
						return "JAVA";
					case SeatUtil.TRACE_OO:
						return "Object Oriented";
					case SeatUtil.TRACE_ROUTINE:
						return "Routine";
					default:
						return "Undetermined";
				}
			}
			// disable display of packge/class info, they ar econsidered nott important
			// furthermore, these info can be found in model view
			if (id.equals(PROPERTY_TRACE_PACKAGE))
				return state.getPackageList().size()+"";			
			if (id.equals(PROPERTY_TRACE_CLASS))
				return state.getClassList().size()+"";			
//			for (int i=0;i<pls.length;i++)
//				if (id.equals(pls[i]))
//					return pls[i];
//			for (int i=0;i<cls.length;i++)
//				if (id.equals(cls[i]))
//					return cls[i];
		}
		
		if (id.equals(PROPERTY_NAME))
			return path.getName();
		if (id.equals(PROPERTY_FULLNAME))
			return path.getFullQualifiedName();
		if (id.equals(PROPERTY_TYPE))
			return path.getType();
		if (id.equals(PROPERTY_NPARENTS)) {
			String par=getDistinctParents(path.getElement());
//			Node node=path.getElement();
//			for (int i=0;i<node.getNumberOfParents();i++) {
//				par+=NameParsing.getShortClassName(node.getParentAt(i))+"."+ NameParsing.getShortMethodName(node.getParentAt(i));
//				par+="/";
//			}
			return par;
//			return getDistinctParents(path.getElement())+" distinct method(s): ";			
		}
		if (id.equals(PROPERTY_NCHILDREN)) {
			String par=getDistinctChildren(path.getElement());
//			Node node=path.getElement();
//			for (int i=0;i<node.getNumberOfChildren();i++) {
//				par+=NameParsing.getShortClassName(node.getChildAt(i))+"."+ NameParsing.getShortMethodName(node.getChildAt(i));
//				par+="/";
//			}
			return par;
		}
//			return getDistinctChildren(path.getElement())+" distinct method(s)";
		if (id.equals(PROPERTY_SCOPE))
			return path.getScope();
		if (id.equals(PROPERTY_PARENT)) 
			if (path.getParent()!=null)
				return path.getParent().getFullQualifiedName();
			else return "";
		if (id.equals(PROPERTY_CHILDREN))
			return path.getNumOfUnhiddenChildren()+"";
		if (id.equals(PROPERTY_LEVEL))
			return path.getLevelOfCall()+"";
		if (id.equals(PROPERTY_LINENO))
			return path.getLineNo()+"";
		if (id.equals(PROPERTY_DESCRIPTION))
			return path.getDescription();
				
		return null;

	}

	/**
	 * Test if the property is set. Always return false.
	 * @see org.eclipse.ui.views.properties.IPropertySource#isPropertySet(java.lang.Object)
	 */
	public boolean isPropertySet(Object id) {
		// TODO Auto-generated method stub
		return false;
	}

	/**
	 * Reset the property to its default value.Empty method.
	 * @see org.eclipse.ui.views.properties.IPropertySource#resetPropertyValue(java.lang.Object)
	 */
	public void resetPropertyValue(Object id) {
		// TODO Auto-generated method stub

	}

	/**
	 * Set a property value. Empty method.
	 * @see org.eclipse.ui.views.properties.IPropertySource#setPropertyValue(java.lang.Object, java.lang.Object)
	 */
	public void setPropertyValue(Object id, Object value) {
		// TODO Auto-generated method stub

	}
	
	private String getDistinctChildren(Node node) {
		int n=node.getNumberOfChildren();
		String ms=" distinct method(s)";
		if (n==0) return "0 "+ms;
		else {
			ArrayList al=new ArrayList();
			for (int i=0;i<n;i++)
				if (!al.contains(node.getChildAt(i)))
					al.add(node.getChildAt(i));
			StringBuffer all=new StringBuffer(al.size()+ms+": ");
			for (int i=0;i<al.size();i++) {
				all.append(((Node)al.get(i)).getLabel());
				if (i>10) {
					all.append("...");
					break;
				}				
			}
			return all.toString();			
		}
	}
	
	private String getDistinctParents(Node node) {
		int n=node.getNumberOfParents();
		String ms=" distinct method(s)";
		if (n==0) return "0 "+ms;
		else {
			ArrayList al=new ArrayList();
			for (int i=0;i<n;i++)
				if (!al.contains(node.getParentAt(i)))
					al.add(node.getParentAt(i));
			StringBuffer all=new StringBuffer(al.size()+ms+": ");
			for (int i=0;i<al.size();i++) {
				all.append(((Node)al.get(i)).getLabel());
				if (i>10) {
					all.append("...");
					break;
				}				
			}
			return all.toString();			
		}
	}	

}
