/*
 * Created on Jul 11, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package seat.ui.views;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

import seat.SeatUtil;


/**
 * Defines a perspective for trace exploration. It contains a exploration view, a tree view of current active
 * exploration, and related property window. This class is used by perspectivePage extension point.
 * 
 * @see org.eclipse.ui.IPerspectiveFactory
 * @author lfu
 *
 */
public class TracePerspective implements IPerspectiveFactory {

	/**
	 * Creates the initial screen layout of perspective views. User may reset to this default 
	 * layout by [Reset Perpective] menu item.
	 * @param IPageLaout layout- primary layout to be operated on. 
	 * (non-Javadoc)
	 * @see org.eclipse.ui.IPerspectiveFactory#createInitialLayout(org.eclipse.ui.IPageLayout)
	 */
	public void createInitialLayout(IPageLayout layout) {
		// TODO Auto-generated method stub
		defineLayout(layout);

	}
	
	// define the layout of the prospective with 3 views and a property page
	private void defineLayout(IPageLayout layout) {
		String editAreaID=layout.getEditorArea();
		
		IFolderLayout topLeft=layout.createFolder("topLeft",IPageLayout.LEFT,0.3f,editAreaID);
		topLeft.addView(IPageLayout.ID_RES_NAV);
		
		IFolderLayout bottomLeft=layout.createFolder("bottomLeft",IPageLayout.BOTTOM,0.6f,"topLeft");
		bottomLeft.addView(SeatUtil.VIEW_CONTROLPANEL);
		bottomLeft.addView(IPageLayout.ID_PROP_SHEET);

		IFolderLayout bottomRight=layout.createFolder("bottomRight",IPageLayout.BOTTOM,0.6f,editAreaID);
		bottomRight.addView(SeatUtil.VIEW_MODEL);
//		bottomRight.addView(SeatUtil.VIEW_STATISTICS);
		bottomRight.addView(SeatUtil.VIEW_PATTERN);
		bottomRight.addView(SeatUtil.VIEW_UTILITY);
		bottomRight.addView(SeatUtil.VIEW_BOOKMARK);
	}

}
